Index: /LMDZ4/trunk/libf/filtrez/mod_filtre_fft.F90
===================================================================
--- /LMDZ4/trunk/libf/filtrez/mod_filtre_fft.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/filtrez/mod_filtre_fft.F90	(revision 1403)
@@ -1,2 +1,6 @@
+!
+! $Id$
+!
+
 MODULE mod_filtre_fft
 
@@ -23,5 +27,6 @@
     INTEGER            :: index_vp(iim)
     INTEGER            :: i,j
-    
+    INTEGER            :: l,ll_nb
+
     index_vp(1)=1
     DO i=1,iim/2
@@ -98,7 +103,13 @@
     ENDDO
     
-    
+#ifdef FFT_FFTW
+
+    WRITE (*,*)"COTH jfiltnu,jfiltsu,jfiltnv,jjm-jfiltsv"
+    WRITE (*,*)jfiltnu,jfiltsu,jfiltnv,jjm-jfiltsv
+    WRITE (*,*)MAX(jfiltnu-2,jjm-jfiltsu,jfiltnv-2,jjm-jfiltsv)+1
+    CALL Init_FFT(iim,(llm+1)*(MAX(jfiltnu-2,jjm-jfiltsu,jfiltnv-2,jjm-jfiltsv)+1))
+#else    
     CALL Init_FFT(iim,(jjm+1)*(llm+1))
-        
+#endif        
     
   END SUBROUTINE Init_filtre_fft
@@ -118,11 +129,8 @@
 
     REAL               :: vect(iim+inc,jj_end-jj_begin+1,nbniv)
-!    REAL               :: vect_test(iim+inc,jj_end-jj_begin+1,nbniv)
-    COMPLEX*16         :: TF_vect(iim/2+1,jj_end-jj_begin+1,nbniv)
-!    COMPLEX*16         :: TF_vect_test(iim/2+1,jj_end-jj_begin+1,nbniv)
+    COMPLEX         :: TF_vect(iim/2+1,jj_end-jj_begin+1,nbniv)
     INTEGER            :: nb_vect
     INTEGER :: i,j,l
     INTEGER :: ll_nb
-!    REAL               :: vect_tmp(iim+inc,jj_end-jj_begin+1,nbniv)
     
     ll_nb=0
@@ -140,15 +148,5 @@
     nb_vect=(jj_end-jj_begin+1)*ll_nb
 
-!    vect_tmp=vect
-
     CALL FFT_forward(vect,TF_vect,nb_vect)
-
-!    CALL FFT_forward(vect,TF_vect_test,nb_vect)
-!      PRINT *,"XXXXXXXXXXXXX Filtre_u_FFT xxxxxxxxxxxx"
-!      DO j=1,jj_end-jj_begin+1
-!      DO i=1,iim/2+1
-!         PRINT *,"====",i,j,"----->",TF_vect_test(i,j,1)
-!       ENDDO
-!      ENDDO
 
     DO l=1,ll_nb
@@ -159,15 +157,8 @@
       ENDDO
     ENDDO
-       
+  
     CALL FFT_backward(TF_vect,vect,nb_vect)
-!    CALL FFT_backward(TF_vect_test,vect_test,nb_vect)
-          
-!      PRINT *,"XXXXXXXXXXXXX Filtre_u_FFT xxxxxxxxxxxx"
-!      DO j=1,jj_end-jj_begin+1
-!         DO i=1,iim
-!           PRINT *,"====",i,j,"----->",vect_test(i,j,1)
-!         ENDDO
-!      ENDDO
-
+      
+      
     ll_nb=0
 !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
@@ -199,5 +190,5 @@
 
     REAL               :: vect(iim+inc,jj_end-jj_begin+1,nbniv)
-    COMPLEX*16         :: TF_vect(iim/2+1,jj_end-jj_begin+1,nbniv)
+    COMPLEX            :: TF_vect(iim/2+1,jj_end-jj_begin+1,nbniv)
     INTEGER            :: nb_vect
     INTEGER :: i,j,l
@@ -260,6 +251,6 @@
     REAL,INTENT(INOUT) :: vect_inout(iim+1,nlat,nbniv)
 
-    REAL               :: vect(iim+inc,jj_end-jj_begin+1,nbniv)
-    COMPLEX*16         :: TF_vect(iim/2+1,jj_end-jj_begin+1,nbniv)
+     REAL               :: vect(iim+inc,jj_end-jj_begin+1,nbniv)
+    COMPLEX            :: TF_vect(iim/2+1,jj_end-jj_begin+1,nbniv)
     INTEGER            :: nb_vect
     INTEGER :: i,j,l
@@ -305,37 +296,4 @@
 
   END SUBROUTINE Filtre_inv_fft  
-  
-  
-!  SUBROUTINE get_ll_index(nbniv,ll_index,ll_nb)
-!  IMPLICIT NONE
-!    INTEGER,INTENT(IN)  :: nbniv
-!    INTEGER,INTENT(OUT) :: ll_index(nbniv)
-!    INTEGER,INTENT(OUT) :: ll_nb
-!
-!    INTEGER :: l,ll_begin, ll_end
-!   INTEGER :: omp_rank,omp_size
-!   INTEGER :: OMP_GET_NUM_THREADS
-!   INTEGER :: omp_chunk
-!   EXTERNAL OMP_GET_NUM_THREADS
-!   INTEGER :: OMP_GET_THREAD_NUM
-!   EXTERNAL OMP_GET_THREAD_NUM
-!
-!   
-!   omp_size=OMP_GET_NUM_THREADS()
-!   omp_rank=OMP_GET_THREAD_NUM()    
-!   omp_chunk=nbniv/omp_size+min(1,MOD(nbniv,omp_size))
-!   
-!   ll_begin=omp_rank*OMP_CHUNK+1
-!   ll_nb=0
-!   DO WHILE (ll_begin<=nbniv)
-!     ll_end=min(ll_begin+OMP_CHUNK-1,nbniv)
-!     DO l=ll_begin,ll_end
-!       ll_nb=ll_nb+1
-!       ll_index(ll_nb)=l
-!     ENDDO
-!     ll_begin=ll_begin+omp_size*OMP_CHUNK
-!   ENDDO
-!  
-!  END SUBROUTINE get_ll_index
    
 END MODULE mod_filtre_fft
Index: /LMDZ4/trunk/libf/grid/fxy_new.h
===================================================================
--- /LMDZ4/trunk/libf/grid/fxy_new.h	(revision 1402)
+++ /LMDZ4/trunk/libf/grid/fxy_new.h	(revision 1403)
@@ -8,13 +8,13 @@
 c....stretching in x...
 c
-        ripx(  ri )= (ri-1.0) *2.*pi/FLOAT(iim) 
+        ripx(  ri )= (ri-1.0) *2.*pi/REAL(iim) 
         fx  (  ri )= ripx(ri) + transx  +
      *         alphax * SIN( ripx(ri)+transx-pxo ) - pi
-        fxprim(ri) = 2.*pi/FLOAT(iim)  *
+        fxprim(ri) = 2.*pi/REAL(iim)  *
      *        ( 1.+ alphax * COS( ripx(ri)+transx-pxo ) )
 
 c....stretching in y...
 c
-        bigy(rj)   = 2.* (FLOAT(jjp1)-rj ) *pi/jjm
+        bigy(rj)   = 2.* (REAL(jjp1)-rj ) *pi/jjm
         fy(rj)     =  ( bigy(rj) + transy  +
      *        alphay * SIN( bigy(rj)+transy-pyo ) ) /2.  - pi/2.
Index: /LMDZ4/trunk/libf/grid/fxy_reg.h
===================================================================
--- /LMDZ4/trunk/libf/grid/fxy_reg.h	(revision 1402)
+++ /LMDZ4/trunk/libf/grid/fxy_reg.h	(revision 1403)
@@ -13,13 +13,13 @@
 c
 c
-      fy    ( rj ) =    pi/FLOAT(jjm) * ( 0.5 * FLOAT(jjm) +  1. - rj  )
-      fyprim( rj ) =    pi/FLOAT(jjm)
+      fy    ( rj ) =    pi/REAL(jjm) * ( 0.5 * REAL(jjm) +  1. - rj  )
+      fyprim( rj ) =    pi/REAL(jjm)
 
-c     fy(rj)=ASIN(1.+2.*((1.-rj)/FLOAT(jjm)))
+c     fy(rj)=ASIN(1.+2.*((1.-rj)/REAL(jjm)))
 c     fyprim(rj)=1./SQRT((rj-1.)*(jjm+1.-rj))
 
-      fx    ( ri ) = 2.*pi/FLOAT(iim) * ( ri - 0.5*  FLOAT(iim) - 1. )
-c     fx    ( ri ) = 2.*pi/FLOAT(iim) * ( ri - 0.5* ( FLOAT(iim) + 1.) )
-      fxprim( ri ) = 2.*pi/FLOAT(iim)
+      fx    ( ri ) = 2.*pi/REAL(iim) * ( ri - 0.5*  REAL(iim) - 1. )
+c     fx    ( ri ) = 2.*pi/REAL(iim) * ( ri - 0.5* ( REAL(iim) + 1.) )
+      fxprim( ri ) = 2.*pi/REAL(iim)
 c
 c
Index: /LMDZ4/trunk/libf/grid/fxy_sin.h
===================================================================
--- /LMDZ4/trunk/libf/grid/fxy_sin.h	(revision 1402)
+++ /LMDZ4/trunk/libf/grid/fxy_sin.h	(revision 1403)
@@ -13,10 +13,10 @@
 c
 c
-      fy(rj)=ASIN(1.+2.*((1.-rj)/FLOAT(jjm)))
+      fy(rj)=ASIN(1.+2.*((1.-rj)/REAL(jjm)))
       fyprim(rj)=1./SQRT((rj-1.)*(jjm+1.-rj))
 
-      fx    ( ri ) = 2.*pi/FLOAT(iim) * ( ri - 0.5*  FLOAT(iim) - 1. )
-c     fx    ( ri ) = 2.*pi/FLOAT(iim) * ( ri - 0.5* ( FLOAT(iim) + 1.) )
-      fxprim( ri ) = 2.*pi/FLOAT(iim)
+      fx    ( ri ) = 2.*pi/REAL(iim) * ( ri - 0.5*  REAL(iim) - 1. )
+c     fx    ( ri ) = 2.*pi/REAL(iim) * ( ri - 0.5* ( REAL(iim) + 1.) )
+      fxprim( ri ) = 2.*pi/REAL(iim)
 c
 c
Index: /LMDZ4/trunk/libf/grid/fxyprim.h
===================================================================
--- /LMDZ4/trunk/libf/grid/fxyprim.h	(revision 1402)
+++ /LMDZ4/trunk/libf/grid/fxyprim.h	(revision 1403)
@@ -13,13 +13,13 @@
 c
 c
-      fy    ( rj ) =    pi/FLOAT(jjm) * ( 0.5 * FLOAT(jjm) +  1. - rj  )
-      fyprim( rj ) =    pi/FLOAT(jjm)
+      fy    ( rj ) =    pi/REAL(jjm) * ( 0.5 * REAL(jjm) +  1. - rj  )
+      fyprim( rj ) =    pi/REAL(jjm)
 
-c     fy(rj)=ASIN(1.+2.*((1.-rj)/FLOAT(jjm)))
+c     fy(rj)=ASIN(1.+2.*((1.-rj)/REAL(jjm)))
 c     fyprim(rj)=1./SQRT((rj-1.)*(jjm+1.-rj))
 
-      fx    ( ri ) = 2.*pi/FLOAT(iim) * ( ri - 0.5*  FLOAT(iim) - 1. )
-c     fx    ( ri ) = 2.*pi/FLOAT(iim) * ( ri - 0.5* ( FLOAT(iim) + 1.) )
-      fxprim( ri ) = 2.*pi/FLOAT(iim)
+      fx    ( ri ) = 2.*pi/REAL(iim) * ( ri - 0.5*  REAL(iim) - 1. )
+c     fx    ( ri ) = 2.*pi/REAL(iim) * ( ri - 0.5* ( REAL(iim) + 1.) )
+      fxprim( ri ) = 2.*pi/REAL(iim)
 c
 c
Index: /LMDZ4/trunk/libf/phylmd/aaam_bud.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/aaam_bud.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/aaam_bud.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       subroutine aaam_bud (iam,nlon,nlev,rjour,rsec,
@@ -117,10 +117,15 @@
       REAL BLSU(801,401),BLSV(801,401)
       REAL ZLON(801),ZLAT(401)
+
+      CHARACTER (LEN=20) :: modname='aaam_bud'
+      CHARACTER (LEN=80) :: abort_message
+
+
 C
 C  PUT AAM QUANTITIES AT ZERO:
 C
       if(iim+1.gt.801.or.jjm+1.gt.401)then
-      print *,' Pb de dimension dans aaam_bud'
-      stop
+        abort_message = 'Pb de dimension dans aaam_bud'
+        CALL abort_gcm (modname,abort_message,1)
       endif
 
@@ -128,6 +133,6 @@
       hadley=1.e18
       hadday=1.e18*24.*3600.
-      dlat=xpi/float(jjm)
-      dlon=2.*xpi/float(iim) 
+      dlat=xpi/REAL(jjm)
+      dlon=2.*xpi/REAL(iim) 
       
       do iax=1,3
Index: /LMDZ4/trunk/libf/phylmd/aeropt.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/aeropt.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/aeropt.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE aeropt(pplay, paprs, t_seri, msulfate, RHcl,
@@ -39,4 +39,8 @@
       REAL alpha_aer_sulfate(nbre_RH,5)   !--unit m2/g SO4
       REAL alphasulfate      
+
+      CHARACTER (LEN=20) :: modname='aeropt'
+      CHARACTER (LEN=80) :: abort_message
+
 c
 c Proprietes optiques
@@ -85,5 +89,8 @@
         rh=MIN(RHcl(i,k)*100.,RH_MAX)
         RH_num = INT( rh/10. + 1.)
-        IF (rh.LT.0.) STOP 'aeropt: RH < 0 not possible'
+        IF (rh.LT.0.) THEN
+          abort_message = 'aeropt: RH < 0 not possible'
+          CALL abort_gcm (modname,abort_message,1)
+        ENDIF
         IF (rh.gt.85.) RH_num=10
         IF (rh.gt.90.) RH_num=11
Index: /LMDZ4/trunk/libf/phylmd/albedo.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/albedo.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/albedo.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 c
@@ -67,5 +67,5 @@
 c prend en compte l'autre moitie de la journee):
       DO k = 1, npts
-         rmu = aa + bb * COS(FLOAT(k)/FLOAT(npts)*zpi)
+         rmu = aa + bb * COS(REAL(k)/REAL(npts)*zpi)
          rmu = MAX(0.0, rmu)
          fauxo = (1.47-ACOS(rmu))/.15
@@ -110,5 +110,5 @@
 c prend en compte l'autre moitie de la journee):
       DO k = 1, npts
-         rmu = aa + bb * COS(FLOAT(k)/FLOAT(npts)*zpi)
+         rmu = aa + bb * COS(REAL(k)/REAL(npts)*zpi)
          rmu = MAX(0.0, rmu)
 cIM cf. PB      alb = 0.058/(rmu + 0.30)
Index: /LMDZ4/trunk/libf/phylmd/calcul_simulISCCP.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/calcul_simulISCCP.h	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/calcul_simulISCCP.h	(revision 1403)
@@ -1,4 +1,4 @@
 c
-c $Header$
+c $Id$
 c
 c on appelle le simulateur ISCCP toutes les 3h
@@ -18,5 +18,5 @@
        sunlit(i)=1 
        IF(rmu0(i).EQ.0.) sunlit(i)=0
-       nbsunlit(1,i,n)=FLOAT(sunlit(i))
+       nbsunlit(1,i,n)=REAL(sunlit(i))
       ENDDO
 c
@@ -88,9 +88,11 @@
            print*,'seed=0 i paprs aa seed_re',
      .     i,paprs(i,2),aa,seed_re(i,n)
-           STOP
+           abort_message = ''
+           CALL abort_gcm (modname,abort_message,1)
           ELSE IF(seed(i,n).LT.0) THEN
            print*,'seed < 0, i seed itap paprs',i,
      .     seed(i,n),itap,paprs(i,2)
-           STOP
+           abort_message = ''
+           CALL abort_gcm (modname,abort_message,1)
           ENDIF
 c
Index: /LMDZ4/trunk/libf/phylmd/calltherm.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/calltherm.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/calltherm.F90	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       subroutine calltherm(dtime  &
@@ -8,5 +8,5 @@
      &      ,fm_therm,entr_therm,detr_therm,zqasc,clwcon0,lmax,ratqscth,  &
      &       ratqsdiff,zqsatth,Ale_bl,Alp_bl,lalim_conv,wght_th, &
-     &       zmax0,f0,zw2,fraca)
+     &       zmax0,f0,zw2,fraca,ztv,zpspsk,ztla,zthl)
 
       USE dimphy
@@ -45,7 +45,12 @@
 !********************************************************
 !     declarations
+      LOGICAL flag_bidouille_stratocu
       real fmc_therm(klon,klev+1),zqasc(klon,klev)
       real zqla(klon,klev)
       real zqta(klon,klev)
+      real ztv(klon,klev)
+      real zpspsk(klon,klev)
+      real ztla(klon,klev)
+      real zthl(klon,klev)
       real wmax_sec(klon)
       real zmax_sec(klon)
@@ -82,4 +87,7 @@
 !      save zentr_therm,zfm_therm
 
+      character (len=20) :: modname='calltherm'
+      character (len=80) :: abort_message
+
       integer i,k
       logical, save :: first=.true.
@@ -136,5 +144,5 @@
          if(nbptspb.GT.0) print*,'Number of points with q_seri(i,k)<=0 ',nbptspb   
 
-         zdt=dtime/float(nsplit_thermals)
+         zdt=dtime/REAL(nsplit_thermals)
          do isplit=1,nsplit_thermals
 
@@ -172,5 +180,7 @@
      &      ,tau_thermals,3)
           else if (iflag_thermals.eq.11) then
-            stop 'cas non prevu dans calltherm'
+              abort_message = 'cas non prevu dans calltherm'
+              CALL abort_gcm (modname,abort_message,1)
+
 !           CALL thermcell_pluie(klon,klev,zdt  &
 !   &      ,pplay,paprs,pphi,zlev  &
@@ -187,6 +197,6 @@
      &      ,r_aspect_thermals,l_mix_thermals,w2di_thermals  &
      &      ,tau_thermals)
-          else if (iflag_thermals.ge.13) then
-            CALL thermcell_main(itap,klon,klev,zdt  &
+          else if (iflag_thermals==13.or.iflag_thermals==14) then
+            CALL thermcellV0_main(itap,klon,klev,zdt  &
      &      ,pplay,paprs,pphi,debut  &
      &      ,u_seri,v_seri,t_seri,q_seri  &
@@ -197,11 +207,29 @@
      &      ,tau_thermals,Ale,Alp,lalim_conv,wght_th &
      &      ,zmax0,f0,zw2,fraca)
+          else if (iflag_thermals==15.or.iflag_thermals==16) then
+
+!            print*,'THERM iflag_thermas_ed=',iflag_thermals_ed
+            CALL thermcell_main(itap,klon,klev,zdt  &
+     &      ,pplay,paprs,pphi,debut  &
+     &      ,u_seri,v_seri,t_seri,q_seri  &
+     &      ,d_u_the,d_v_the,d_t_the,d_q_the  &
+     &      ,zfm_therm,zentr_therm,zdetr_therm,zqasc,zqla,lmax  &
+     &      ,ratqscth,ratqsdiff,zqsatth  &
+     &      ,r_aspect_thermals,l_mix_thermals &
+     &      ,tau_thermals,iflag_thermals_ed,Ale,Alp,lalim_conv,wght_th &
+     &      ,zmax0,f0,zw2,fraca,ztv,zpspsk &
+     &      ,ztla,zthl)
+           if (prt_level.gt.10) write(lunout,*)'Apres thermcell_main OK'
+         else
+           abort_message = 'Cas des thermiques non prevu'
+           CALL abort_gcm (modname,abort_message,1)
          endif
 
+       flag_bidouille_stratocu=iflag_thermals.eq.14.or.iflag_thermals.eq.16
 
       fact(:)=0.
       DO i=1,klon
-       logexpr1(i)=iflag_thermals.lt.14.or.weak_inversion(i).gt.0.5
-       IF(logexpr1(i)) fact(i)=1./float(nsplit_thermals)
+       logexpr1(i)=flag_bidouille_stratocu.or.weak_inversion(i).gt.0.5
+       IF(logexpr1(i)) fact(i)=1./REAL(nsplit_thermals)
       ENDDO
 
@@ -235,11 +263,12 @@
             qmemoire(:,:)=q_seri(:,:)
             q_seri(:,:) = q_seri(:,:) + d_q_the(:,:)
+           if (prt_level.gt.10) write(lunout,*)'Apres apres thermcell_main OK'
 
        DO i=1,klon
         if(prt_level.GE.10) print*,'calltherm i Alp_bl Alp Ale_bl Ale',i,Alp_bl(i),Alp(i),Ale_bl(i),Ale(i)
             fm_therm(i,klev+1)=0.
-            Ale_bl(i)=Ale_bl(i)+Ale(i)/float(nsplit_thermals)
+            Ale_bl(i)=Ale_bl(i)+Ale(i)/REAL(nsplit_thermals)
 !            write(22,*)'ALE CALLTHERM',Ale_bl(i),Ale(i)
-            Alp_bl(i)=Alp_bl(i)+Alp(i)/float(nsplit_thermals)
+            Alp_bl(i)=Alp_bl(i)+Alp(i)/REAL(nsplit_thermals)
 !            write(23,*)'ALP CALLTHERM',Alp_bl(i),Alp(i)
        ENDDO
@@ -260,5 +289,4 @@
 !    &         'fm=',zfm_therm(i,k),'entr=',entr_therm(i,k)
                  endif
-!       stop
             ENDDO
             ENDDO
Index: /LMDZ4/trunk/libf/phylmd/calwake.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/calwake.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/calwake.F	(revision 1403)
@@ -1,2 +1,5 @@
+!
+! $Id$
+!
       SUBROUTINE CALWAKE(paprs,pplay,dtime
      :             ,t,q,omgb
@@ -189,8 +192,8 @@
      $                ,Cstar,d_deltat_gw
      $                ,d_deltatw,d_deltaqw)
-
-      DO i=1,klon 
-       IF (ktopw(i) .GT. 0) THEN
-         DO l=1,klev
+c
+      DO l=1,klev
+       DO i=1,klon 
+        IF (ktopw(i) .GT. 0) THEN
            wake_deltat(i,l)= dtw(i,l)
            wake_deltaq(i,l)= dqw(i,l)
@@ -212,7 +215,5 @@
            wake_ddeltat(i,l) = d_deltatw(i,l)
            wake_ddeltaq(i,l) = d_deltaqw(i,l)
-         ENDDO
-       ELSE
-         DO l = 1,klev
+        ELSE
            wake_deltat(i,l)= 0.
            wake_deltaq(i,l)= 0.
@@ -222,4 +223,6 @@
            wake_dtKE(i,l) = 0.
            wake_dqKE(i,l) = 0.
+ 	   wake_dtPBL(i,l) = 0.
+	   wake_dqPBL(i,l) = 0.
            wake_omg(i,l) = 0.
            wake_dp_deltomg(i,l) = 0.
@@ -230,7 +233,11 @@
            undi_t(i,l)=te(i,l)
            undi_q(i,l)=qe(i,l)
-         ENDDO
-       ENDIF
-
+           wake_ddeltat(i,l) = 0.
+           wake_ddeltaq(i,l) = 0.
+        ENDIF
+       ENDDO
+      ENDDO
+c
+      DO i=1,klon 
        wake_h(i)= hw(i)
        wake_s(i)= sigmaw(i)
@@ -241,10 +248,9 @@
        wake_Cstar(i) = Cstar(i)
        wake_dens(i) = wdens(i)
-c
-cIM 290108 999  CONTINUE
-c
-      ENDDO
+      ENDDO
+c
       RETURN
       END
+
       SUBROUTINE CALWAKE_scal(paprs,pplay,dtime
      :             ,t,q,omgb
Index: /LMDZ4/trunk/libf/phylmd/clesphys.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/clesphys.h	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/clesphys.h	(revision 1403)
@@ -1,2 +1,3 @@
+
 !
 ! $Id$
@@ -48,4 +49,6 @@
        INTEGER lev_histdayNMC
        Integer lev_histins, lev_histLES  
+
+
 !IM ok_histNMC  : sortie fichiers niveaux de pression (histmthNMC, histdayNMC, histhfNMC)
 !IM freq_outNMC : frequences de sortie fichiers niveaux de pression (histmthNMC, histdayNMC, histhfNMC)
@@ -55,4 +58,5 @@
        LOGICAL ok_histNMC(3)
        REAL freq_outNMC(3) , freq_calNMC(3)
+
        CHARACTER(len=4) type_run
 ! aer_type: pour utiliser un fichier constant dans readaerosol 
@@ -69,4 +73,5 @@
        LOGICAL :: ok_strato
        LOGICAL :: ok_hines
+       INTEGER :: nseuil
 
        COMMON/clesphys/cycle_diurne, soil_model, new_oliq,              &
@@ -78,4 +83,5 @@
      &     , f_cdrag_ter,f_cdrag_oce,f_rugoro                           &
      &     , lev_histhf, lev_histday, lev_histmth                       &
+
      &     , lev_histins, lev_histLES, lev_histdayNMC                   &
      &     , pasphys, ok_histNMC, freq_outNMC, freq_calNMC              &
@@ -88,5 +94,5 @@
      &     , ok_lic_melt, cvl_corr, aer_type                            &
      &     , qsol0, iflag_rrtm, ok_strato,ok_hines,ecrit_LES            &
-     &     , co2_ppm0
+     &     , co2_ppm0, nseuil
      
 !$OMP THREADPRIVATE(/clesphys/)
Index: /LMDZ4/trunk/libf/phylmd/cloudth.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cloudth.F90	(revision 1403)
+++ /LMDZ4/trunk/libf/phylmd/cloudth.F90	(revision 1403)
@@ -0,0 +1,263 @@
+       SUBROUTINE cloudth(ngrid,klev,ind2,  &
+     &           ztv,po,zqta,fraca, & 
+     &           qcloud,ctot,zpspsk,paprs,ztla,zthl, &
+     &           ratqs,zqs,t)
+
+
+      IMPLICIT NONE
+
+
+!===========================================================================
+! Auteur : Arnaud Octavio Jam (LMD/CNRS)
+! Date : 25 Mai 2010
+! Objet : calcule les valeurs de qc et rneb dans les thermiques
+!===========================================================================
+
+
+#include "YOMCST.h"
+#include "YOETHF.h"
+#include "FCTTRE.h"
+#include "iniprint.h"
+#include "thermcell.h"
+
+      INTEGER itap,ind1,ind2
+      INTEGER ngrid,klev,klon,l,ig 
+      
+      REAL ztv(ngrid,klev)
+      REAL po(ngrid)
+      REAL zqenv(ngrid)   
+      REAL zqta(ngrid,klev)
+          
+      REAL fraca(ngrid,klev+1)
+      REAL zpspsk(ngrid,klev)
+      REAL paprs(ngrid,klev+1)
+      REAL ztla(ngrid,klev)
+      REAL zthl(ngrid,klev)
+
+      REAL zqsatth(ngrid,klev)
+      REAL zqsatenv(ngrid,klev)
+      
+      
+      REAL sigma1(ngrid,klev)                                                         
+      REAL sigma2(ngrid,klev)
+      REAL qlth(ngrid,klev)
+      REAL qlenv(ngrid,klev)
+      REAL qltot(ngrid,klev) 
+      REAL cth(ngrid,klev)  
+      REAL cenv(ngrid,klev)   
+      REAL ctot(ngrid,klev)
+      REAL rneb(ngrid,klev)
+      REAL t(ngrid,klev)                                                                  
+      REAL qsatmmussig1,qsatmmussig2,sqrt2pi,pi
+      REAL rdd,cppd,Lv
+      REAL alth,alenv,ath,aenv
+      REAL sth,senv,sigma1s,sigma2s,xth,xenv
+      REAL Tbef,zdelta,qsatbef,zcor
+      REAL alpha,qlbef  
+      REAL ratqs(ngrid,klev) ! determine la largeur de distribution de vapeur
+      
+      REAL zpdf_sig(ngrid),zpdf_k(ngrid),zpdf_delta(ngrid)
+      REAL zpdf_a(ngrid),zpdf_b(ngrid),zpdf_e1(ngrid),zpdf_e2(ngrid) 
+      REAL zqs(ngrid), qcloud(ngrid)
+      REAL erf
+
+
+
+
+
+!      print*,ngrid,klev,ind1,ind2,ztv(ind1,ind2),po(ind1),zqta(ind1,ind2), &
+!     &       fraca(ind1,ind2),zpspsk(ind1,ind2),paprs(ind1,ind2),ztla(ind1,ind2),zthl(ind1,ind2), &
+!     &       'verif'
+
+
+!      LOGICAL active(ngrid)   
+      
+!-----------------------------------------------------------------------------------------------------------------
+! Initialisation des variables réelles
+!-----------------------------------------------------------------------------------------------------------------
+      sigma1(:,:)=0.
+      sigma2(:,:)=0.
+      qlth(:,:)=0.
+      qlenv(:,:)=0.  
+      qltot(:,:)=0.
+      rneb(:,:)=0.
+      qcloud(:)=0.
+      cth(:,:)=0.
+      cenv(:,:)=0.
+      ctot(:,:)=0.
+      qsatmmussig1=0.
+      qsatmmussig2=0.
+      rdd=287.04
+      cppd=1005.7
+      pi=3.14159 
+      Lv=2.5e6
+      sqrt2pi=sqrt(2.*pi)
+
+
+
+!------------------------------------------------------------------------------------------------------------------
+! Calcul de la fraction du thermique et des écart-types des distributions
+!------------------------------------------------------------------------------------------------------------------                 
+      do ind1=1,ngrid
+
+      if ((ztv(ind1,1).gt.ztv(ind1,2)).and.(fraca(ind1,ind2).gt.1.e-10)) then 
+
+      zqenv(ind1)=(po(ind1)-fraca(ind1,ind2)*zqta(ind1,ind2))/(1.-fraca(ind1,ind2))
+
+
+!      zqenv(ind1)=po(ind1)
+      Tbef=zthl(ind1,ind2)*zpspsk(ind1,ind2)
+      zdelta=MAX(0.,SIGN(1.,RTT-Tbef))
+      qsatbef= R2ES * FOEEW(Tbef,zdelta)/paprs(ind1,ind2)
+      qsatbef=MIN(0.5,qsatbef)
+      zcor=1./(1.-retv*qsatbef)
+      qsatbef=qsatbef*zcor
+      zqsatenv(ind1,ind2)=qsatbef
+
+
+
+
+      alenv=(0.622*Lv*zqsatenv(ind1,ind2))/(rdd*zthl(ind1,ind2)**2)  
+      aenv=1./(1.+(alenv*Lv/cppd))
+      senv=aenv*(po(ind1)-zqsatenv(ind1,ind2)) 
+
+
+
+
+      Tbef=ztla(ind1,ind2)*zpspsk(ind1,ind2)
+      zdelta=MAX(0.,SIGN(1.,RTT-Tbef))
+      qsatbef= R2ES * FOEEW(Tbef,zdelta)/paprs(ind1,ind2)
+      qsatbef=MIN(0.5,qsatbef)
+      zcor=1./(1.-retv*qsatbef)
+      qsatbef=qsatbef*zcor
+      zqsatth(ind1,ind2)=qsatbef
+            
+      alth=(0.622*Lv*zqsatth(ind1,ind2))/(rdd*ztla(ind1,ind2)**2)   
+      ath=1./(1.+(alth*Lv/cppd))
+      sth=ath*(zqta(ind1,ind2)-zqsatth(ind1,ind2)) 
+      
+      
+
+!-----------------------------------------------------------------------------------------------------------------
+! Calcul des écart-types pour s
+!-----------------------------------------------------------------------------------------------------------------
+!      alpha=0.5*(fraca(ind1,ind2)+fraca(ind1,ind2-1))
+!      sigma1s=(Max(1.2*fraca(ind1,ind2)*(sth-senv)**2,(senv/100)**2))**0.5
+!      sigma2s=((0.021/(fraca(ind1,ind2)+0.0)**0.5)*(sth-senv)**2+(sth/100)**2)**0.5 
+!      sigma1s=(1.5**0.5)*(fraca(ind1,ind2)**0.65)*(sth-senv)+0.000045
+!      sigma2s=0.1265*(sth-senv)/(fraca(ind1,ind2)+0.0)**0.35+0.000045     
+
+      sigma1s=(1.1**0.5)*(fraca(ind1,ind2)**0.6)/(1-fraca(ind1,ind2))*((sth-senv)**2)**0.5+0.00003
+      sigma2s=0.11*((sth-senv)**2)**0.5/(fraca(ind1,ind2)+0.02)**0.4+0.00003  
+
+!      sigma1s=(1.5**0.5)*(alpha**0.65)*(sth-senv)+0.000045
+!      sigma2s=0.1265*(sth-senv)/alpha**0.35+0.000045
+      
+!      sigma1s=(2.8**0.5)*(0.1**0.7)*(sth-senv)+0.00002
+!      sigma2s=((0.126/(0.1)**0.3)*(sth-senv))+0.00002
+
+
+ 
+!-----------------------------------------------------------------------------------------------------------------
+! Calcul de l'eau condensée et de la couverture nuageuse
+!-----------------------------------------------------------------------------------------------------------------
+      sqrt2pi=sqrt(2.*pi)
+      xth=sth/(sqrt(2.)*sigma2s)
+      xenv=senv/(sqrt(2.)*sigma1s)
+      cth(ind1,ind2)=0.5*(1.+1.*erf(xth))
+      cenv(ind1,ind2)=0.5*(1.+1.*erf(xenv)) 
+      ctot(ind1,ind2)=fraca(ind1,ind2)*cth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*cenv(ind1,ind2)   
+!      ctot(ind1,ind2)=alpha*cth(ind1,ind2)+(1.-1.*alpha)*cenv(ind1,ind2) 
+
+
+
+      qlth(ind1,ind2)=sigma2s*((exp(-1.*xth**2)/sqrt2pi)+xth*sqrt(2.)*cth(ind1,ind2))
+      qlenv(ind1,ind2)=sigma1s*((exp(-1.*xenv**2)/sqrt2pi)+xenv*sqrt(2.)*cenv(ind1,ind2))   
+      qltot(ind1,ind2)=fraca(ind1,ind2)*qlth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qlenv(ind1,ind2)
+!      qltot(ind1,ind2)=alpha*qlth(ind1,ind2)+(1.-1.*alpha)*qlenv(ind1,ind2)
+     
+
+!      print*,senv,sth,sigma1s,sigma2s,fraca(ind1,ind2),'senv et sth et sig1 et sig2 et alpha'
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      if (ctot(ind1,ind2).lt.1.e-10) then
+      ctot(ind1,ind2)=0.
+      qcloud(ind1)=zqsatenv(ind1,ind2) 
+
+      else   
+                
+      ctot(ind1,ind2)=ctot(ind1,ind2) 
+      qcloud(ind1)=qltot(ind1,ind2)/ctot(ind1,ind2)+zqs(ind1)
+
+      endif                           
+      
+          
+!     print*,sth,sigma2s,qlth(ind1,ind2),ctot(ind1,ind2),qltot(ind1,ind2),'verif'
+
+
+      else  ! gaussienne environnement seule
+      
+      zqenv(ind1)=po(ind1)
+      Tbef=t(ind1,ind2)
+      zdelta=MAX(0.,SIGN(1.,RTT-Tbef))
+      qsatbef= R2ES * FOEEW(Tbef,zdelta)/paprs(ind1,ind2)
+      qsatbef=MIN(0.5,qsatbef)
+      zcor=1./(1.-retv*qsatbef)
+      qsatbef=qsatbef*zcor
+      zqsatenv(ind1,ind2)=qsatbef
+      
+
+!      qlbef=Max(po(ind1)-zqsatenv(ind1,ind2),0.)
+      zthl(ind1,ind2)=t(ind1,ind2)*(101325/paprs(ind1,ind2))**(rdd/cppd)
+      alenv=(0.622*Lv*zqsatenv(ind1,ind2))/(rdd*zthl(ind1,ind2)**2)  
+      aenv=1./(1.+(alenv*Lv/cppd))
+      senv=aenv*(po(ind1)-zqsatenv(ind1,ind2)) 
+      
+!      if (zqenv(ind1).gt.0.005) then
+      sigma1s=0.005*zqenv(ind1)
+!      else 
+!      sigma1s=0.0005
+!      endif
+
+!      sigma1s=ratqs(ind1,ind2)*zqenv(ind1)
+
+
+
+!      sigma1s=0.00003
+      sqrt2pi=sqrt(2.*pi)
+      xenv=senv/(sqrt(2.)*sigma1s)
+      ctot(ind1,ind2)=0.5*(1.+1.*erf(xenv))
+      qltot(ind1,ind2)=sigma1s*((exp(-1.*xenv**2)/sqrt2pi)+xenv*sqrt(2.)*cenv(ind1,ind2))
+      
+      if (ctot(ind1,ind2).lt.1.e-3) then
+      ctot(ind1,ind2)=0.
+      qcloud(ind1)=zqsatenv(ind1,ind2) 
+
+      else   
+                
+      ctot(ind1,ind2)=ctot(ind1,ind2) 
+      qcloud(ind1)=qltot(ind1,ind2)/ctot(ind1,ind2)+zqsatenv(ind1,ind2)
+
+      endif    
+ 
+ 
+ 
+ 
+ 
+ 
+      endif   
+      enddo
+     
+      return
+      end
+
+
+
+
+
+                                                                            
+
+
+
+
+
Index: /LMDZ4/trunk/libf/phylmd/conema3.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/conema3.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/conema3.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       SUBROUTINE conema3 (dtime,paprs,pplay,t,q,u,v,tra,ntra,
@@ -360,5 +360,5 @@
       cape(i) = em_CAPE
       wd(i) = em_wd
-      rflag(i) = float(iflag)
+      rflag(i) = REAL(iflag)
 c SB      kbas(i) = em_bas
 c SB      ktop(i) = em_top
Index: /LMDZ4/trunk/libf/phylmd/conf_phys.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/conf_phys.F90	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/conf_phys.F90	(revision 1403)
@@ -22,5 +22,6 @@
                        iflag_thermals,nsplit_thermals,tau_thermals, &
                        iflag_thermals_ed,iflag_thermals_optflux, &
-                       iflag_coupl,iflag_clos,iflag_wake, read_climoz)
+                       iflag_coupl,iflag_clos,iflag_wake, read_climoz, &
+                       alp_offset)
 
    use IOIPSL
@@ -28,4 +29,5 @@
    USE phys_cal_mod
    USE carbon_cycle_mod, ONLY : carbon_cycle_tr, carbon_cycle_cpl
+   use control_mod
 
  include "conema3.h"
@@ -37,5 +39,4 @@
 include "clesphys.h"
 include "compbl.h"
-include "control.h"
 include "comsoil.h"
 !
@@ -111,4 +112,6 @@
   integer :: iflag_clos
   integer :: iflag_wake
+  real :: alp_offset
+  REAL, SAVE :: alp_offset_omp
   integer,SAVE :: iflag_coupl_omp,iflag_clos_omp,iflag_wake_omp
   integer,SAVE :: iflag_cvl_sigd_omp
@@ -150,4 +153,5 @@
   REAL,SAVE :: ecrit_LES_omp
   REAL,SAVE :: ecrit_tra_omp
+  INTEGER, SAVE :: nseuil_omp   
   REAL,SAVE :: cvl_corr_omp
   LOGICAL,SAVE :: ok_lic_melt_omp
@@ -1038,4 +1042,12 @@
   call getin('iflag_wake',iflag_wake_omp)
 
+!Config Key  = alp_offset
+!Config Desc =  
+!Config Def  = 0
+!Config Help = 
+!
+  alp_offset_omp = 0.
+  call getin('alp_offset',alp_offset_omp)
+
 !
 !Config Key  = lev_histhf
@@ -1256,4 +1268,14 @@
   ecrit_tra_omp = 30.
   call getin('ecrit_tra',ecrit_tra_omp)
+!
+!Config Key  = nseuil
+!Config Desc = Numero du traceur a partir duquel on ne transporte 
+!              pas par convection
+!Config Def  = 7 !a partir du numero 7 pour les pseudo-traceurs de Remy
+!Config Help =
+!
+  nseuil_omp = 7
+  call getin('nseuil',nseuil_omp)
+!
 !
 !Config Key  = ecrit_reg
@@ -1531,4 +1553,5 @@
     iflag_clos = iflag_clos_omp
     iflag_wake = iflag_wake_omp
+    alp_offset = alp_offset_omp
     iflag_cvl_sigd = iflag_cvl_sigd_omp
     type_run = type_run_omp
@@ -1548,4 +1571,5 @@
     ecrit_mth = ecrit_mth_omp
     ecrit_tra = ecrit_tra_omp
+    nseuil = nseuil_omp
     ecrit_reg = ecrit_reg_omp
     cvl_corr = cvl_corr_omp
@@ -1708,4 +1732,6 @@
   write(numout,*)' Fmax = ', Fmax
   write(numout,*)' alphas = ', alphas
+  write(numout,*)' iflag_wake = ', iflag_wake
+  write(numout,*)' alp_offset = ', alp_offset
 
   write(numout,*)' lonmin lonmax latmin latmax bilKP_ins =',&
@@ -1713,4 +1739,5 @@
   write(numout,*)' ecrit_ hf, ins, day, mth, reg, tra, ISCCP, LES',&
    ecrit_hf, ecrit_ins, ecrit_day, ecrit_mth, ecrit_reg, ecrit_tra, ecrit_ISCCP, ecrit_LES
+  write(numout,*)' nseuil ',nseuil
 
   write(numout,*) 'ok_strato = ', ok_strato
Index: /LMDZ4/trunk/libf/phylmd/convect2.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/convect2.F	(revision 1402)
+++ /LMDZ4/trunk/libf/phylmd/convect2.F	(revision 1403)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
       subroutine convect2(ncum,idcum,len,nd,ndp1,nl,minorig,
